/*
    
    Copyright (C) 2007  William Quincy 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/    

#include "Map.h"


Map::Map(Bitmap Parent, int x, int y, int Width,int Height)
{
    Canvas = create_sub_bitmap(Parent,x,y,Width,Height);
    bmp = create_bitmap(MAPX,MAPY);
    clear_bitmap(bmp);
}    

Map::~Map()
{
    destroy_bitmap(bmp);
    destroy_bitmap(Canvas);
}

void Map::UpdateTiles(World &world)
{
    int x,y;
    
    for(y=0;y<MaxGridY;y++)
    {
        for(x=0;x<MaxGridX;x++)
        {
         stretch_blit(world.GetTileBmp(x,y),bmp,0,0,TILEWIDTH,TILEHEIGHT,(x<<1)+1,(y<<1)+1,2,2);  
        }    
    }        
}      

void Map::UpdateTile(World &world, int x, int y)
{
    stretch_blit(world.GetTileBmp(x,y),bmp,0,0,TILEWIDTH,TILEHEIGHT,(x<<1)+1,(y<<1)+1,2,2);  
}       

void Map::Blit()
{
    blit(bmp,Canvas,0,0,0,0,bmp->w,bmp->h);
}    
