/*
    
    Copyright (C) 2007  William Quincy 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/    

#include "Racer.h"

Racer::Racer()
{
    Angle = 0;
    Pos.x = 0;
    Pos.z = 0;
    Y = 14;
    Vel.x=0.0;
    Vel.z=0.0;
    YVelocity = 0.0;
    MaxVelocity=8;
    HP = 150.0;
    Mass = 1000.0;
    
}    

void Racer::SetKeys(int Mapping[])
{
    for(int i=0;i<KEYMAX;i++)
    {
     KeyMap[i] = Mapping[i];   
    }    
}    

void Racer::Move(World &world)
{
    int TurnRate;
    static int ActRelease = 0;
    YVelocity -= world.GetGravity();
    Frame = 0;
    if(key[KeyMap[KEYLEFT]]!=0)
    {
       if(Vel.x<0){
          Angle-=18;
       }
       else{
          Angle+=18;
  
     }   
       if(Angle<0){Angle+=MAXDEGREES;}
       if(Angle>=MAXDEGREES){Angle-=MAXDEGREES;}
      
    }
    if(key[KeyMap[KEYRIGHT]]!=0)
    {
       if(Vel.x<0)
       {
          Angle+=18;
       }
       else
       {
          Angle-=18;
       }

       if(Angle<0){Angle+=MAXDEGREES;}
       if(Angle>=MAXDEGREES){Angle-=MAXDEGREES;}
    }

    if(key[KeyMap[KEYGAS]]!=0)
    {
       Vel.x+=0.2;
       if(Vel.x>MaxVelocity){Vel.x = MaxVelocity;}
    }
    else
    if (key[KeyMap[KEYBRAKE]]!=0)
    {
       Vel.x-=0.2;
       if(Vel.x<-(MaxVelocity>>1)){Vel.x = -(MaxVelocity>>1);}
    }
    else
    {
         if(Vel.x>0)
         {
            Vel.x-=0.09;
            if(Vel.x<0){Vel.x = 0;}
         }
         else
         {
            Vel.x+=0.09;
            if(Vel.x>0){Vel.x = 0;}
         }
         
    }
    if(key[KeyMap[KEYACTION]]!=0 && Y == 0)
    {
       
       YVelocity = 7;
       ActRelease = 1;
    }
    TurnRate = 18;

  
    float dx,dy;
    dy=-Vel.x*SinTable[Angle];
    dx=Vel.x*CosTable[Angle];
    Pos.x+=dx;
    Pos.z+=dy;
    if(Pos.x+dx > 3045 ){Pos.x=-3045;}
    if(Pos.z+dy > 3045 ){Pos.z=-3045;}
    if(Pos.x+dx < -3045 ){Pos.x=3045;}
    if(Pos.z+dy < -3045 ){Pos.z=3045;}
    Y += (int)(YVelocity);
    if (Y < 0){Y = 0;}
    if (Y > MAXJUMP){Y = MAXJUMP;}
    
    
}    
   
/*void Racer::Move(World &world)
{
    //int TurnRate;
    static int ActRelease = 0;
    int temp;
    
    YVelocity -= .6;//world.GetGravity();
    TurnRate = 0;
    Frame = 0;
    if(key[KeyMap[KEYLEFT]]!=0)
    {
       if(Speed > 0 && Y == 0)
       {
          Angle+=8*Speed;
       }    
       
       Frame = 36;
    }
    if(key[KeyMap[KEYRIGHT]]!=0)
    {
       if(Speed > 0 && Y == 0)
       {
           Angle-=8*Speed;
       }    
      
       Frame = 72;
       
    }
   
    if(key[KeyMap[KEYGAS]]!=0)
    {
       //Vel.x+=0.2;
       //if(Vel.x>MaxVelocity){Vel.x = MaxVelocity;}
       HP = 250.0;
    }
    else
    if (key[KeyMap[KEYBRAKE]]!=0)
    {
       HP = -150.0;
       //Vel.x-=0.2;
       //if(Vel.x<-(MaxVelocity>>1)){Vel.x = -(MaxVelocity>>1);}
    }
    else
    {    
       if(Speed > 0){
        HP  -=Speed;
        if (HP<0){HP=0;}}
        else{
            HP=0;}
        
          //   if(Vel.x>0)
        // {
        //    Vel.x-=0.09;
        //    if(Vel.x<0){Vel.x = 0;}
        // }
        // else
        // {
        //    Vel.x+=0.09;
        //    if(Vel.x>0){Vel.x = 0;}
        // }
         
    }
    //if(key[KeyMap[KEYACTION]]==0) ActRelease =0;
    if(key[KeyMap[KEYACTION]]!=0 && Y == 0)
    {
       
       YVelocity = 8;
       ActRelease = 1;
       
       //ObjY+=3;
       //if(ObjY>MAXJUMP){ObjY=MAXJUMP;}
    }
    if(key[KEY_STOP])
    {
     YVelocity = 2;
    }    
  ///  if(key[KEY_COMMA])
  ///  {
  //   Y+=1;   
  //  }    
    
    if(Angle<0){Angle+=MAXDEGREES;}
    if(Angle>=MAXDEGREES){Angle-=MAXDEGREES;}
    U.x = CosTable[Angle];
    U.z = -SinTable[Angle];
       
    Tract.x = U.x * HP;// * HP;
    Tract.z = U.z * HP;// * HP;    
    
    Speed = sqrt(Vel.x*Vel.x + Vel.z*Vel.z);
    Drag.x = -5 * Vel.x * Speed;//Vel
    Drag.z = -5 * Vel.z * Speed;//Vel
    
    RR.x = -35 * Vel.x;//Vel
    RR.z = -35 * Vel.z;//Vel
        
    Force.x = Tract.x + Drag.x + RR.x;
    Force.z = Tract.z + Drag.z + RR.z;
        
    Accel.x = Force.x/Mass;
    Accel.z = Force.z/Mass;
    
    Vel.x += Accel.x;
    Vel.z += Accel.z;
    
    Pos.x += Vel.x;
    Pos.z += Vel.z;
    
    //Angle += (int)(TurnRate*Speed);
   // if(Angle<0){Angle+=MAXDEGREES;}
    //if(Angle>=MAXDEGREES){Angle-=MAXDEGREES;}
    
    //if(Angle<0){Angle+=MAXDEGREES;}
    //if(Angle>=MAXDEGREES){Angle-=MAXDEGREES;}
        
    Y += (int)(YVelocity);
    if (Y < 0){Y = 0;}
    if (Y > MAXJUMP){Y = MAXJUMP;}
    
    if(Speed < .2) Speed = 0.0;
    
} */   

void Racer::DrawPos(Bitmap Dest, int col)
{
    int MapX = (int)(Pos.x)>>4;
    int MapY = (int)(Pos.z)>>4;
    rectfill(Dest,MapX,MapY,MapX+2,MapY+2,col);    
}   

void Racer::Draw(Bitmap Dest, float CamX, float CamZ, int CamY, int CamAngle, int hori) 
{
     float z = Pos.z - CamZ-1;
     float x = Pos.x - CamX-1;

     int theangle =  CamAngle+QUARTERCIRCLE;
     if(theangle>=MAXDEGREES){theangle-=MAXDEGREES;}

     float world_z = (z * CosTable[theangle]) + (x * SinTable[theangle])-0.055555;
     float world_x = (z * SinTable[theangle]) - (x * CosTable[theangle])-0.055555;
       
     float objscreen_x = (Dest->w>>1) + (SCALEX / world_z) * world_x - 0.055555;
     float objscreen_y = (((CamY * SCALEY) - ((Y-(ScaleY/YOffset)) * SCALEY)) / world_z) + hori - 0.055555;
     int bheight = (int)(Height * (ScaleY / world_z) - 0.055555);
     int bwidth  =  (int)(Width * (ScaleX / world_z) - 0.055555);
     
     int screen_x = (int)(objscreen_x - (bwidth>>1));
     int screen_y = (int)(objscreen_y - bheight);
     
    // char Tempstring[32];
    // sprintf(Tempstring,"%d",theangle);
    // textout(Dest,font,Tempstring,10,10,makecol(255,255,0));
     int temp;
     int Fudge;
     int FudgeX;
     
     //Fudge just fudges the sprites angle a little
     //towards the edges of the screen.
     //Remove Fudge from this line:
     //   temp = ObjAngle - (CamAngle - Fudge);
     //to see what it does.     
     //It works well enough if you have maybe 10 frames
     //around a circle. But, we have 36 so it makes it
     //more obvious that this is not accurate. But, it still
     //looks better than having only 10 frames.
     //But, since I have 36 frames, I should go ahead
     //and figure out the math to rotate the sprites
     //better. But there are 10(360 based) degrees
     //between each frame so that is as acurte
     //as you could get it anyway.
     
     //If you want you can increase accuracy by
     //using trig to factor in the angle btween the
     //camera and the object. And correcting for perspective.
     //Or by using the pos of the object realative
     //to the camera. i.e. is obj x < and obj y >
     //of obj x > and obj y >. ect. And fudging accordingly.
     //Using trig is probavly best on todays computers.
     FudgeX = screen_x+(bwidth >>1);
     Fudge = ((FudgeX - 240)>>1)+36;
     //if(FudgeX < 120){Fudge-=36;}
     temp = Angle - (CamAngle - Fudge); 
     while (temp < 0) temp += MAXDEGREES; 
     while (temp >= MAXDEGREES) temp -= MAXDEGREES;
                      
     temp = ((temp>>3)/10) + Frame ;
     masked_stretch_blit(bmp,Dest,(temp % CELLSPERROW) * Width,
                         (temp / CELLSPERROW) * Height, Width, Height,
                         screen_x, screen_y, bwidth, bheight);
     
     //vline(Dest,screen_x+(bwidth>>1),0,180,makecol(255,255,0));                    
                           
}    

void Racer::DisplayStat()
{
    char Temp[32];
    sprintf(Temp,"g: %f X %f",TurnRate,TurnRate);
    textout_ex(screen,font,Temp,50,50,makecol(255,255,0),-1);
    
}

