/*
    
    Copyright (C) 2007  William Quincy 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/    

#ifndef _RACER_H
#define _RACER_H 

#include "Object.h"
#include "world.h"



#define KEYGAS 0
#define KEYBRAKE 1
#define KEYLEFT 2
#define KEYRIGHT 3
#define KEYACTION 4
#define KEYMAX 5

#define CELLSPERROW 6

class Racer : public Object
{
private:  
    int KeyMap[KEYMAX];
    int ChaseCounter;
    int TurnRate;
    float HP;
    float Mass;
    float Speed;
   // float SteerAngle;
    VECT2d U;
    VECT2d Tract;
    VECT2d Drag;
    VECT2d RR;
    VECT2d Accel;
    VECT2d Force;
    
    
 /*
	float	wheelbase;		// wheelbase in m
	float	b;				// in m, distance from CG to front axle
	float	c;				// in m, idem to rear axle
	float	h;				// in m, height of CM from ground
	float	inertia;		// in kg.m
	float	length,width;
	float	wheellength,wheelwidth;

	
	VEC2	position_wc;		// position of car centre in world coordinates
	VEC2	velocity_wc;		// velocity vector of car in world coordinates

	float	angle;				// angle of car body orientation (in rads)
	float	angularvelocity;

	float	steerangle;			// angle of steering (input)
	float	throttle;			// amount of throttle (input)
	float	brake;				// amount of braking (input)

    
    
    */
    
            

public:
    Racer();
    //****virtual****//
    void Move(World &world);
    void Draw(Bitmap Dest, float CamX, float CamZ, int CamY, int CamAngle, int hori);
    
    //****member****//
    void SetKeys(int Mapping[]);
    void DrawPos(Bitmap Dest, int col);  
    void DisplayStat();
    
}; 

#endif
