/*
    
    Copyright (C) 2007  William Quincy 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/    

#include "plane.h"

void Plane::Move()
{//TODO: make Roto and Animate methods
   //Angle += 10;
  // if(Angle>=MAXDEGREES){Angle-=MAXDEGREES;}
   if(Type && OBJTYPEANI)
   {
      Frame++;
      if(Frame > NumFrames) {Frame = 0;}
   }      
   
}    

void Plane::Draw(Bitmap Dest, float CamX, float CamZ, int CamY, int CamAngle, int hori) 
{
     float z,x;
     float world_z,world_x;
     float objscreen_x, objscreen_y ;
     float zup, xup;
     int y;
     int Angle2;
     
     int theangle =  CamAngle+QUARTERCIRCLE;
     if(theangle>=MAXDEGREES){theangle-=MAXDEGREES;}
     Angle2 = Angle+QUARTERCIRCLE;
     if(Angle2>=MAXDEGREES){Angle2-=MAXDEGREES;}
     for(int i=0;i<4;i++)
     {
         switch(i)
         {
             case 0:
                 if(Type == BILLBOARD)
                 {
                     zup = -CosTable[Angle] * (Width>>1);
                     xup = -SinTable[Angle] * (Width>>1);
         
                     z = (Pos.z + zup) - CamZ;
                     x = (Pos.x + xup) - CamX;
                     y = Y + Height;
                 }
                 else
                 {
                     zup = -CosTable[Angle] * (Width>>1);
                     xup = -SinTable[Angle] * (Width>>1);
         
                     z = (Pos.z + zup) - CamZ;
                     x = (Pos.x + xup) - CamX;
                     y = 0;
                     
                     } 
                 world_z = (z * CosTable[theangle]) + (x * SinTable[theangle])-0.055555;
                 world_x = (z * SinTable[theangle]) - (x * CosTable[theangle])-0.055555;
             
                 objscreen_x = (Dest->w>>1) + (SCALEX / world_z) * world_x - 0.055555;
                 objscreen_y = (((CamY * SCALEY) - (y * SCALEY)) / world_z) + hori- 0.055555;
         
                 ScreenP1.x = objscreen_x;
                 ScreenP1.y = objscreen_y;
                 ScreenP1.z = sqrt((z * z)+(x * x));
                 //ScreenP1.z = fabs(CamX-x) + fabs (CamZ-z) ;
                 ScreenP1.c = Color;//makecol(255,0,0); 
                 ScreenP1.u = Frame * CellW;
                 ScreenP1.v = 0;
                 break;
             
             case 1:
                if(Type == BILLBOARD)
                 {
                     zup = -CosTable[Angle] * (Width>>1);
                     xup = -SinTable[Angle] * (Width>>1);
         
                     z = (Pos.z + zup) - CamZ;
                     x = (Pos.x + xup) - CamX;
                     y = Y;     
                 }
                 else
                 {
                     zup = -CosTable[Angle2] * (Width>>1);
                     xup = -SinTable[Angle2] * (Width>>1);
         
                     z = (Pos.z + zup) - CamZ;
                     x = (Pos.x + xup) - CamX;
                     y = 0;
                     
                 }
                 world_z = (z * CosTable[theangle]) + (x * SinTable[theangle])-0.055555;
                 world_x = (z * SinTable[theangle]) - (x * CosTable[theangle])-0.055555;
             
                 objscreen_x = (Dest->w>>1) + (SCALEX / world_z) * world_x- 0.055555;
                 objscreen_y = (((CamY * SCALEY) - (y * SCALEY)) / world_z) + hori- 0.055555;
          
                 ScreenP2.x = objscreen_x;
                 ScreenP2.y = objscreen_y;
                 ScreenP2.z = sqrt((z * z)+(x * x));
                 //ScreenP2.z = fabs(CamX-x) + fabs (CamZ-z) ;
                 ScreenP2.c = Color;//makecol(255,0,0); 
                 ScreenP2.u = Frame * CellW;
                 ScreenP2.v = CellH;
                 break;        
             
             case 2:
                 if(Type == BILLBOARD)
                 {
                     zup = CosTable[Angle] * (Width>>1);
                     xup = SinTable[Angle] * (Width>>1);
         
                     z = (Pos.z + zup) - CamZ;
                     x = (Pos.x + xup) - CamX;
                     y = Y;  
                     
                 }
                 else
                 {
                     zup = CosTable[Angle] * (Width>>1);
                     xup = SinTable[Angle] * (Width>>1);
         
                     z = (Pos.z + zup) - CamZ;
                     x = (Pos.x + xup) - CamX;
                     y = 0;  
                     
                 }        
                 
                 world_z = (z * CosTable[theangle]) + (x * SinTable[theangle])-0.055555;
                 world_x = (z * SinTable[theangle]) - (x * CosTable[theangle])-0.055555;
             
                 objscreen_x = (Dest->w>>1) + (SCALEX / world_z) * world_x - 0.055555;
                 objscreen_y = (((CamY * SCALEY) - (y * SCALEY)) / world_z) + hori - 0.055555;
              
                 ScreenP3.x = objscreen_x;
                 ScreenP3.y = objscreen_y;
                 ScreenP3.z = sqrt((z * z)+(x * x));
                 //ScreenP3.z = fabs(CamX-x) + fabs (CamZ-z) ;
                 ScreenP3.c = Color;//makecol(255,0,0); 
                 ScreenP3.u = (Frame * CellW) + CellW;
                 ScreenP3.v = CellH;
                 break;      
             
             case 3:
                 if(Type == BILLBOARD)
                 {
                     zup = CosTable[Angle] * (Width>>1);
                     xup = SinTable[Angle] * (Width>>1);
         
                     z = (Pos.z + zup) - CamZ;
                     x = (Pos.x + xup) - CamX;
                     y = Y + Height; 
                 }
                 else
                 {
                     zup = CosTable[Angle2] * (Width>>1);
                     xup = SinTable[Angle2] * (Width>>1);
         
                     z = (Pos.z + zup) - CamZ;
                     x = (Pos.x + xup) - CamX;
                     y = 0;  
                     
                 }
                 world_z = (z * CosTable[theangle]) + (x * SinTable[theangle])-0.055555;
                 world_x = (z * SinTable[theangle]) - (x * CosTable[theangle])-0.055555;
             
                 objscreen_x = (Dest->w>>1) + (SCALEX / world_z) * world_x - 0.055555;
                 objscreen_y = (((CamY * SCALEY) - (y * SCALEY)) / world_z) + hori- 0.055555;
         
                 ScreenP4.x = objscreen_x;
                 ScreenP4.y = objscreen_y;
                 ScreenP4.z = sqrt((z * z)+(x * x));
                 //ScreenP4.z = fabs(CamX -x) + fabs(CamZ-z) ;
                 ScreenP4.c = Color;//makecol(255,0,0); 
                 ScreenP4.u = (Frame * CellW) + CellW;
                 ScreenP4.v = 0;
                 break;   
        }            
    }  
    if(bmp)
    {
        quad3d_f(Dest, POLYTYPE_PTEX_MASK, bmp, &ScreenP1, &ScreenP2, &ScreenP3, &ScreenP4);
    }
    else
    {
        quad3d_f(Dest, POLYTYPE_FLAT, NULL, &ScreenP1, &ScreenP2, &ScreenP3, &ScreenP4);
    }            
}    



