/*
    
    Copyright (C) 2007  William Nelson Quincy Jr

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/    

#include "pointer.h"

CPointer::CPointer()
{
    Angle = 0;
    Pos.x = 0;
    Pos.z = 0;
    Y = 14;
    Vel.x=0.2;
    YVelocity = 0.0;
   MaxVelocity=8;
}    

void CPointer::SetKeys(int Mapping[])
{
    for(int i=0;i<KEYMAX;i++)
    {
        KeyMap[i] = Mapping[i];   
    }   
 
}    
   
void CPointer::Move(World &world)
{
    int TurnRate;
    static int ActRelease = 0;
    YVelocity -= world.GetGravity();
    Frame = 0;
    if(key[KeyMap[KEYLEFT]]!=0)
    {
       if(Vel.x<0){
          Angle-=18;
       }
       else{
          Angle+=18;
  
     }   
       if(Angle<0){Angle+=MAXDEGREES;}
       if(Angle>=MAXDEGREES){Angle-=MAXDEGREES;}
      
    }
    if(key[KeyMap[KEYRIGHT]]!=0)
    {
       if(Vel.x<0)
       {
          Angle+=18;
       }
       else
       {
          Angle-=18;
       }

       if(Angle<0){Angle+=MAXDEGREES;}
       if(Angle>=MAXDEGREES){Angle-=MAXDEGREES;}
    }

    if(key[KeyMap[KEYGAS]]!=0)
    {
       Vel.x+=0.2;
       if(Vel.x>MaxVelocity){Vel.x = MaxVelocity;}
    }
    else
    if (key[KeyMap[KEYBRAKE]]!=0)
    {
       Vel.x-=0.2;
       if(Vel.x<-(MaxVelocity>>1)){Vel.x = -(MaxVelocity>>1);}
    }
    else
    {
         if(Vel.x>0)
         {
            Vel.x-=0.09;
            if(Vel.x<0){Vel.x = 0;}
         }
         else
         {
            Vel.x+=0.09;
            if(Vel.x>0){Vel.x = 0;}
         }
         
    }
    if(key[KeyMap[KEYACTION]]!=0 && Y == 0)
    {
       
       YVelocity = 8;
       ActRelease = 1;
    }
    TurnRate = 18;

  
    float dx,dy;
    dy=-Vel.x*SinTable[Angle];
    dx=Vel.x*CosTable[Angle];
    Pos.x+=dx;
    Pos.z+=dy;
    if(Pos.x+dx > MaxGridX * TILEWIDTH ){Pos.x=MaxGridX * TILEWIDTH ;}
    if(Pos.z+dy > MaxGridY * TILEHEIGHT  ){Pos.z=MaxGridY * TILEHEIGHT ;}
    if(Pos.x+dx < 3 ){Pos.x=3;}
    if(Pos.z+dy < 3 ){Pos.z=3;}
    Y += (int)(YVelocity);
    if (Y < 0){Y = 0;}
    if (Y > MAXJUMP){Y = MAXJUMP;}
    
    
}    

void CPointer::DrawPos(Bitmap Dest, int col)
{
    int MapX = (int)(Pos.x)>>4;
    int MapY = (int)(Pos.z)>>4;
    rectfill(Dest,MapX,MapY,MapX+2,MapY+2,col);    
}   

void CPointer::Draw(Bitmap Dest, float CamX, float CamZ, int CamY, int CamAngle, int hori) 
{
     float z = Pos.z - CamZ-1;
     float x = Pos.x - CamX-1;

     int theangle =  CamAngle+QUARTERCIRCLE;
     if(theangle>=MAXDEGREES){theangle-=MAXDEGREES;}

     float world_z = (z * CosTable[theangle]) + (x * SinTable[theangle])-0.055555;
     float world_x = (z * SinTable[theangle]) - (x * CosTable[theangle])-0.055555;
       
     float objscreen_x = (Dest->w>>1) + (SCALEX / world_z) * world_x - 0.055555;
     float objscreen_y = (((CamY * SCALEY) - ((Y-(ScaleY/YOffset)) * SCALEY)) / world_z) + hori - 0.055555;
     int bheight = (int)(Height * (ScaleY / world_z) - 0.055555);
     int bwidth  =  (int)(Width * (ScaleX / world_z) - 0.055555);
     
     int screen_x = (int)(objscreen_x - (bwidth>>1));
     int screen_y = (int)(objscreen_y - bheight);
     
    
     masked_stretch_blit(bmp,Dest,0,0, Width, Height,
                         screen_x, screen_y, bwidth, bheight);
     
                           
}    



